﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Collections;

namespace howto_use_bitarray
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Demonstrate the BitArray class.
        private void Form1_Load(object sender, EventArgs e)
        {
            string txt = "";

            // Set all bits to true then false.
            BitArray bits = new BitArray(32);
            bits.SetAll(true);
            txt += "True:       " + BitArrayToString(bits) + "\r\n";
            bits.SetAll(false);
            txt += "False:      " + BitArrayToString(bits) + "\r\n";

            // Set bits[i] true if i is a Fibonacci number.
            BitArray is_fibonacci = new BitArray(bits.Length);
            for (int i = 0; i < bits.Length; i++)
                is_fibonacci[i] = IsFibonacci(i);
            txt += "Fibonacci:  " +
                BitArrayToString(is_fibonacci) + "\r\n";

            // Invert the bits.
            is_fibonacci.Not();
            for (int i = 0; i < bits.Length; i++)
                bits[i] = IsFibonacci(i);
            txt += "~Fibonacci: " +
                BitArrayToString(is_fibonacci) + "\r\n";

            // Set a bit true if i is a perfect square.
            BitArray is_square = new BitArray(bits.Length);
            for (int i = 0; i < bits.Length; i++)
                is_square[i] = IsSquare(i);
            txt += "Square:     " +
                BitArrayToString(is_square) + "\r\n";

            // And with is_square.
            BitArray sqaure_and_not_fibonacci =
                is_square.And(is_fibonacci);
            is_fibonacci.Not();
            for (int i = 0; i < bits.Length; i++)
                bits[i] = IsFibonacci(i);
            txt += "Sq && ~Fib: " +
                BitArrayToString(sqaure_and_not_fibonacci);

            // Display the results.
            txtBits.Text = txt;
            txtBits.Select(0, 0);
        }

        // Return true if i is a perfect square.
        private bool IsSquare(int i)
        {
            int sqrt_i = (int)Math.Sqrt(i);
            return (sqrt_i * sqrt_i == i);
        }

        // Return true if i is a Fibonacci number.
        private bool IsFibonacci(int i)
        {
            if (i == 0) return true;

            long fib_i_minus_1 = 0;
            long fib_i = 1;
            while (fib_i < i)
            {
                long fib_i_plus_1 = fib_i + fib_i_minus_1;
                fib_i_minus_1 = fib_i;
                fib_i = fib_i_plus_1;
            }
            return (i == fib_i);
        }

        // Return a string showing the BitArray's values.
        private string BitArrayToString(BitArray bits)
        {
            string result = "";
            foreach (bool value in bits)
            {
                if (value) result += "1";
                else result += "0";
            }
            return result;
        }
    }
}
